﻿using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace InfragisticsTest
{
    public partial class Form1 : Form
    {
        private DataTable _ids = new DataTable();
        private DataTable _children = new DataTable();

        public Form1()
        {
            InitializeComponent();

            _ids.Columns.Add(new DataColumn("ID", typeof(int)));
            DataRow drID1 = _ids.NewRow();
            drID1["ID"] = 1;

            DataRow drID2 = _ids.NewRow();
            drID2["ID"] = 2;

            _ids.Rows.Add(drID1);
            _ids.Rows.Add(drID2);            

            _children.Columns.Add(new DataColumn("Checked", typeof(bool)));
            _children.Columns.Add(new DataColumn("ID", typeof(int)));

            DataRow dr1 = _children.NewRow();
            dr1["Checked"] = true;
            dr1["ID"] = "1";

            _children.Rows.Add(dr1);

            DataRow dr2 = _children.NewRow();
            dr2["Checked"] = true;
            dr2["ID"] = "2";

            _children.Rows.Add(dr2);

            _children.AcceptChanges();

            InitTree();
        }      

        private void InitTree()
        {
            this.ultraTree1.ColumnSetGenerated += UltraTree1_ColumnSetGenerated;

            _children.DefaultView.RowFilter = "Checked = true OR ID = 1";
            ultraTree1.DataSource = _children.DefaultView;
        }

        private void UltraTree1_ColumnSetGenerated(object sender, ColumnSetGeneratedEventArgs e)
        {
            var checkedColumn = e.ColumnSet.Columns["Checked"];
            var checkEditor = new CheckEditor();
            checkEditor.CheckAlign = ContentAlignment.MiddleCenter;
            checkedColumn.Editor = checkEditor;
            checkedColumn.AllowCellEdit = AllowCellEdit.Full;
        }

        private void ultraTree1_Click(object sender, EventArgs e)
        {
            //UltraTree utControl = (UltraTree)sender;
            //var activeCell = utControl.ActiveCell;
            
            //if (activeCell == null) return;

            //var activeNode = activeCell.Node;

            //switch (activeCell.Column.Key)
            //{
            //    case "Checked":
            //        activeCell.AllowEdit = AllowCellEdit.Full;
            //        if ((CheckState)activeCell.Value == CheckState.Unchecked || (CheckState)activeCell.Value == CheckState.Indeterminate)
            //            activeCell.Value = (int)CheckState.Checked;
            //        else if ((CheckState)activeCell.Value == CheckState.Checked)
            //            activeCell.Value = (int)CheckState.Unchecked;

            //        activeNode.Update();
                    
            //        break;
            //}
        }
    }
    
}